#define RFID_READ 0x01

int count=0;

int val;
int val1;
int runs = 0;
const int pingPin = P2_1;
const int pingReceive = P2_6;
const int m1 = P2_3;
const int m2 = P2_4;
const int ledpin = P2_5;
int close =0;
long countt=0;
int open =0;

char inChar ='A';


void setup()
{
  Serial.begin(9600);
  pinMode(P1_3, OUTPUT);
   pinMode(P1_5, OUTPUT);
digitalWrite(P1_3, LOW);
pinMode(m1, OUTPUT);
  pinMode(m2, OUTPUT);
  pinMode(ledpin, OUTPUT);
  pinMode(GREEN_LED, OUTPUT); 


}

void suppressAll()                                //suppresses the "null result" from being printed if no RFID tag is present
{
    if(Serial.available() > 0)
    { Serial.read();
      suppressAll();
    }
}

void loop()
{
 int val;
 long duration, inches, cm;
 
if( count < 50)
{
   digitalWrite(P1_5, HIGH);
  Serial.print("!RW");
  Serial.write(byte(RFID_READ));
  Serial.write(byte(32));

  if(Serial.available() > 0)
  {      
    val = Serial.read();                        //The Serial.read() procedure is called, but the result is not printed because I don't want the "error message: 1" cluttering up the serial monitor
      if (val != 1)                                   //If the error code is anything other than 1, then the RFID tag was not read correctly and any data collected is meaningless. In this case since we don't care about the resultant values they can be suppressed
       {suppressAll();}                              
  }      


 if(Serial.available() > 0) {      
    val = Serial.read();
    Serial.print("1st:");
    Serial.println(val, HEX);
    }

if(Serial.available() > 0) {        
    val = Serial.read();
    Serial.print("2nd:");
    Serial.println(val, HEX);
    }

if(Serial.available() > 0) {      
    val = Serial.read();
    Serial.print("3rd:");
    Serial.println(val, HEX);
    }

if(Serial.available() > 0) {          
    val = Serial.read();
    Serial.print("4th:");
    Serial.println(val, HEX);
    Serial.println("-----------------");
    }  

delay(11);
 
}
else
{
  digitalWrite(P1_5, LOW);
}


count++;
if (count >50)
{
  digitalWrite(P1_3, HIGH);
  delay(10);
     delay(50);
   val1 = Serial.read();
   //delay(50);
   Serial.println(val1);
     pinMode(pingPin, OUTPUT);
  digitalWrite(pingPin, LOW);
  delayMicroseconds(2);
  digitalWrite(pingPin, HIGH);
  delayMicroseconds(5);
  digitalWrite(pingPin, LOW);
  
  pinMode(pingReceive, INPUT);
  duration = pulseIn(pingReceive, HIGH);
  
   inches = microsecondsToInches(duration);
  cm = microsecondsToCentimeters(duration);
  Serial.println(inches);
  
}
else
{
  digitalWrite(P1_3, LOW);
}
if (count == 55)
{
  count =0;
  
}
}





long microsecondsToInches(long microseconds)
{
  // According to Parallax's datasheet for the PING))), there are
  // 73.746 microseconds per inch (i.e. sound travels at 1130 feet per
  // second).  This gives the distance travelled by the ping, outbound
  // and return, so we divide by 2 to get the distance of the obstacle.
  return microseconds / 74 / 2;
}

long microsecondsToCentimeters(long microseconds)
{
  // The speed of sound is 340 m/s or 29 microseconds per centimeter.
  // The ping travels out and back, so to find the distance of the
  // object we take half of the distance travelled.
  return microseconds / 29 / 2;
  

}

