
#define RFID_READ 0x01

int count=0;

int val;
int runs = 0;

void setup()
{
  Serial.begin(9600);
  pinMode(P1_3, OUTPUT);
   pinMode(P1_5, OUTPUT);
//digitalWrite(P1_3, LOW);
//digitalWrite(P1_5, HIGH);
digitalWrite(P1_5, HIGH);
}

void suppressAll()                                //suppresses the "null result" from being printed if no RFID tag is present
{
    if(Serial.available() > 0)
    { Serial.read();
      suppressAll();
    }
}

void loop()
{
 int val;
 
 if (count<10)
 {
   
  Serial.print("!RW");
  Serial.write(byte(RFID_READ));
  Serial.write(byte(32));

  if(Serial.available() > 0)
  {      
    val = Serial.read();                        //The Serial.read() procedure is called, but the result is not printed because I don't want the "error message: 1" cluttering up the serial monitor
      if (val != 1)                                   //If the error code is anything other than 1, then the RFID tag was not read correctly and any data collected is meaningless. In this case since we don't care about the resultant values they can be suppressed
       {suppressAll();}                              
  }      


 if(Serial.available() > 0) {      
    val = Serial.read();
    Serial.print("1st:");
    Serial.println(val, HEX);
    }

if(Serial.available() > 0) {        
    val = Serial.read();
    Serial.print("2nd:");
    Serial.println(val, HEX);
    }

if(Serial.available() > 0) {      
    val = Serial.read();
    Serial.print("3rd:");
    Serial.println(val, HEX);
    }

if(Serial.available() > 0) {          
    val = Serial.read();
    Serial.print("4th:");
    Serial.println(val, HEX);
    Serial.println("-----------------");
    }  

delay(750);
 }
 else
 {
   digitalWrite(P1_5, LOW);
 }
 if (count >10)
 {
   digitalWrite(P1_3, HIGH);
   delay(50);
   val = Serial.read();
   delay(50);
   Serial.println(val);
   
   
   
 }
 else
 {
   digitalWrite(P1_3, HIGH);
 }
// count++;
 if(count == 20)
 {
  count =0; 
 }
 
}

